/*### Данное задание не обязательно для выполнения

## Задание

Реализовать функцию, которая позволит оценить, успеет ли команда разработчиков сдать проект до наступления дедлайна.

#### Технические требования:
- Функция на вход принимает три параметра:
  - массив из чисел, который представляет скорость работы разных членов команды. Количество элементов в массиве означает количество человек в команде. Каждый элемент означает сколько стори поинтов (условная оценка сложности выполнения задачи) может выполнить данный разработчик за 1 день.
  - массив из чисел, который представляет собой беклог (список всех задач, которые необходимо выполнить). Количество элементов в массиве означает количество задач в беклоге. Каждое число в массиве означает количество стори поинтов, необходимых для выполнения данной задачи.
  - дата дедлайна (объект типа Date).
- После выполнения, функция должна посчитать, успеет ли команда разработчиков выполнить все задачи из беклога до наступления дедлайна (работа ведется начиная с сегодняшнего дня). Если да, вывести на экран сообщение: `Все задачи будут успешно выполнены за ? дней до наступления дедлайна!`. Подставить нужное число дней в текст. Если нет, вывести сообщение `Команде разработчиков придется потратить дополнительно ? часов после дедлайна, чтобы выполнить все задачи в беклоге`
- Работа идет по 8 часов в день по будним дням  

#### Литература:
- [Дата и время](https://learn.javascript.ru/datetime)*/

function deadlineAlert (arr1, arr2, date) {
    let teamDayPower = arr1.reduce((prevValue, currValue) => prevValue + currValue);
    let taskPower = arr2.reduce((prevValue, currValue) => prevValue + currValue);
    let currDate = new Date();
    // поскольку мы не знаем, в какое время суток работает команда и, соответственно, сколько рабочих часов осталось у команды в текущий день, отсчет оставшихся до дедлайна дней начинаем с полночи завтрашнего дня: 
    currDate.setHours(0,0,0,0);
    currDate.setDate(currDate.getDate() + 1);
    let daysLeft = (date - currDate)/3600000/24;
    let workingDaysLeft = 0;
    for (i=0; i<daysLeft; i++){
        let tempDate = currDate;
        tempDate.setDate(currDate.getDate() + i);        
        if (tempDate.getDay() != 0 && tempDate.getDay() != 6) {
            ++workingDaysLeft; 
        }
    }
    if ((taskPower/teamDayPower) <= workingDaysLeft){
        return alert (`Все задачи будут успешно выполнены за ${Math.floor(workingDaysLeft-(taskPower/teamDayPower))} дней до наступления дедлайна!`);
    }
    else {
        return alert (`Команде разработчиков придется потратить дополнительно ${Math.floor((taskPower/teamDayPower)-workingDaysLeft)*8 + (taskPower % teamDayPower)} часов после дедлайна, чтобы выполнить все задачи в беклоге`);
    }
    
}

// проверка
let q = [2, 2, 4, 2];
let w = [3, 2, 3, 4, 4, 6];
let deadline = new Date (2018, 8, 30);
deadlineAlert(q, w, deadline);